part of tecfy_basic_package;

abstract class BaseModel {
  String get idValue;
  String get displayName;

  static bool isDefault(String? id) => id != null && id.length < 30;
  // convert service time to DateTime UTC
  static DateTime? parseUTC(String? serverValue,
      {String format = "yyyy-MM-ddTHH:mm", DateTime? defaultValue}) {
    if (serverValue == null) return defaultValue;
    try {
      return intl.DateFormat(format).parseUTC(serverValue);
    } catch (err) {
      return defaultValue;
    }
  }
}
