part of tecfy_basic_package;

class ThemeService {
  static final double containerWidth = 1000;
  static final double menuWidth = 300;

  static final Color mainColor =
      TecfyBasicApp.themeConfig?.mainColor ?? Colors.red;
  static final Color secondryColor =
      TecfyBasicApp.themeConfig?.secondColor ?? Colors.black54;
  static final Color subColor =
      TecfyBasicApp.themeConfig?.subColor ?? Colors.black38;
  static final Color backgroundColor =
      TecfyBasicApp.themeConfig?.backgroundColor ??
          Color.fromRGBO(250, 250, 250, 1);
  static final Color backgroundSecondColor =
      Color.fromRGBO(242, 242, 242, 1); //Gray

  static final Color mainTextColor =
      TecfyBasicApp.themeConfig?.textMainColor ?? Colors.black;
  static final Color textSubColor =
      TecfyBasicApp.themeConfig?.textSubColor ?? Colors.black87;
  static final Color textSelectedColor =
      TecfyBasicApp.themeConfig?.textSelectedColor ?? Colors.black45;
  static final Color textOnSecondColor = Colors.white;
  static final Color textOnMainColor = Colors.white;

  static final Color greenColor = Color.fromRGBO(102, 169, 28, 1);
  static final Color dangerColor = Colors.red; //red
  static final Color mainInvertColor = Colors.orange;
  static final Color validationErrorColors = Colors.red; //red

  static getMainThemeIos() {
    return CupertinoThemeData(
      brightness: Brightness.light,
      barBackgroundColor: Colors.white,
      scaffoldBackgroundColor: Colors.white, // background
      primaryColor: mainColor,
      //primaryContrastingColor: mainColor
    );
  }

  static ThemeData getMainThemeAndroid() {
    return ThemeData(
      primaryColor: mainColor,
      backgroundColor: backgroundColor,
      brightness: Brightness.light,
      errorColor: dangerColor,
      //platform: TargetPlatform.android,
      indicatorColor: secondryColor,
      selectedRowColor: backgroundSecondColor,
      secondaryHeaderColor: secondryColor,
      //textSelectionHandleColor: textSubColor,

      highlightColor: mainColor,

      textSelectionTheme: TextSelectionThemeData(
          selectionColor: mainColor,
          cursorColor: mainColor,
          selectionHandleColor: mainColor),
      // buttonColor: mainColor,
      dividerColor: mainColor,

      hintColor: mainColor,

      shadowColor: mainColor,

      textButtonTheme: TextButtonThemeData(
          style: ButtonStyle(
              foregroundColor: MaterialStateProperty.all<Color>(mainColor))),
      buttonTheme: ButtonThemeData(textTheme: ButtonTextTheme.primary),

      //textSelectionColor: textSelectedColor,
      bottomAppBarColor: backgroundSecondColor,
      fontFamily: TecfyBasicApp.themeConfig?.mainFont,
      //-------------- Active Styles ----------------------

      iconTheme: IconThemeData(color: mainColor, size: 30.0),
      appBarTheme: AppBarTheme(
          titleTextStyle: TextStyle(color: textOnMainColor),
          backgroundColor: mainColor,
          iconTheme: IconThemeData(color: textOnMainColor),
          actionsIconTheme: IconThemeData(color: textOnMainColor),
          toolbarTextStyle: TextStyle(color: textOnMainColor),
          //color: mainColor,
          foregroundColor: textOnMainColor),
      textTheme: TextTheme(
          headline1: TextStyle(fontSize: 20.0),
          subtitle1: TextStyle(
              fontSize: 16.0,
              color: Colors.black45,
              fontWeight: FontWeight.w600),
          bodyText1: TextStyle(
              fontSize: 15.0,
              color: Colors.black45,
              fontWeight: FontWeight.w600)),
      // accentColor: mainColor,

// appBarTheme: AppBarTheme(
//   color: mainColor
// )
      // disabledColor: Colors.blue,
      // primaryColorLight: ThemeService.background2Color,
      // primaryColorDark: ThemeService.mainColor,
      // dividerColor: Colors.black54,
      // scaffoldBackgroundColor: Colors.white, // background
      // canvasColor: Colors.white, // background
      // hintColor: black26Gray,
      // primaryColor: mainColor,
      // highlightColor: Colors.redAccent, // when button pressed
      // splashColor: mainColor,// when press affect
      // toggleableActiveColor: mainColor,
      // errorColor: validationErrorColors,
      // dialogBackgroundColor: Colors.white,// for alerts and choises
      // cardColor: Colors.white,
      // backgroundColor: backgroundColor,
      // unselectedWidgetColor: Colors.black, // radio button
    );
  }

  static TextStyle get labelStyle => TextStyle(
      color: ThemeService.textSubColor,
      fontSize: 13,
      fontWeight: FontWeight.normal);
  static TextStyle get titleStyle =>
      TextStyle(color: Colors.black, fontSize: 15, fontWeight: FontWeight.bold);
  static TextStyle get flatButtonTextStyle =>
      TextStyle(color: mainColor, fontSize: 13, fontWeight: FontWeight.normal);
}
